/**************************************************************************
 
 	pause.c
 
  	Project: RockBlast an asteroid game. 
 
	Copyright (c) Febuary 2001 Garett Spencley
 
   	This program is free software; you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
   	the Free Software Foundation; either version 2, or (at your option)
   	any later version.

   	This program is distributed in the hope that it will be useful,
   	but WITHOUT ANY WARRANTY; without even the implied warranty of
   	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   	GNU General Public License for more details.

   	You should have received a copy of the GNU General Public License
   	along with this program; if not, write to the Free Software Foundation,
   	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 

****************************************************************************/

#include "timer.h"
#include "pause.h"
#include "video.h"
#include "image.h"

object paused;

/*
 * load_data() - load data for pause screen
 */

bool load_data()
{
	paused.image = load_image(DATAFILE("paused.png"), true);
	if(!paused.image) {
		fprintf(stderr, "%s\n", SDL_GetError());
		return false;
	}

	return true;
}

/* 
 * init_data() - initialize data for pause screen
 */

void init_data() 
{
	paused.x = (screen->w / 2) - (paused.image->w / 2);
	paused.y = (screen->h / 2);
}

/*
 * pause_screen() - main event loop for pause screen
 */

void pause_screen()
{
	SDL_Event event;
	bool done = false;

	load_data();
	init_data();
	
	pause_timer();

	while(!done) {

		wait_frame(FPS);

		draw_object(&paused);
		update_screen();

		while(SDL_PollEvent(&event)) {

			if(event.type == SDL_QUIT) 
					QUIT = done = true;

			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_p) {
					done = true;	
				}
			}
		}

		erase_object(&paused);
   	}

	SDL_FreeSurface(paused.image);
	
	SDL_Delay(100);
	flush_event_queue(); 

	unpause_timer();
}
